using UnityEngine;
using System.Collections;

[RequireComponent (typeof (Rigidbody))]
public class FauxGravity : MonoBehaviour {
	
	public GameObject Planet = null;
	public  Vector3 Geocentric = Vector3.zero;
	public float fauxGravity = 10.0f;
	public float GroundedDrag  = 1f;
	private bool grounded = false;
	
	private Vector3 gravityUp;
    private Vector3 localUp;
    private Vector3 localForward;

	
	

	void Start () {
		rigidbody.WakeUp();
		rigidbody.useGravity = false;
		//rigidbody.freezeRotation = true;
	}
	
	void OnCollisionEnter (Collision c) {
		grounded = true;
	}

	void OnCollisionExit (Collision c) {
		grounded = false;
	}

	
	
	void FixedUpdate () {
		AdjustToGravity();
	}
	
	public void AdjustUp() {
		Vector3 geocentric = Geocentric;
		if( Planet != null )
		{
			geocentric = Planet.transform.position + Geocentric;
		}
		gravityUp = transform.position - geocentric;
        gravityUp.Normalize();
		
		// if freeze rotation , auto rotate charactor to geocentric
		if( rigidbody.freezeRotation )
		{
			localUp = transform.up;
	        var q = Quaternion.FromToRotation(localUp, gravityUp);
	        q = q * transform.rotation;
	        transform.rotation = Quaternion.Slerp(transform.rotation, q, 0.1f);
	        localForward = transform.forward;
		}
	}
	
	private void AdjustToGravity () {
		AdjustUp();
		rigidbody.AddForce( gravityUp * -fauxGravity * rigidbody.mass );
		rigidbody.drag = grounded ? GroundedDrag : 0.1f;
	}
	
	
	
	
	// 
	public bool Grounded {
		get { return grounded; }
	}
	
	public Vector3 LocalForward {
		get { return localForward; }
	}
	
	public Vector3 LocalUp {
		get { return localUp; }
	}

	
	
	
}
