using UnityEngine;
using System.Collections;
using System;


[RequireComponent (typeof (FauxGravity))]
public class FauxGravityController : MonoBehaviour {
	
	public float moveSpeed = 10.0f;       // 移動速度

	public float obstacleHeight = 1.0f;	// 障礙可跨過之高度
	
	public float obstacleDistance = 2.0f; // 障礙可接近之距離
	
	public bool canJump = true;   // 是否允許跳躍
	
	public KeyCode jumpKeyCode = KeyCode.Space;      // 跳躍鍵
	
	public float jumpHeight = 2.0f;          // 跳躍高度
	


	public MoveType moveType = MoveType.FpsKey;
	
	public float TurnSpeed = 100f;
	
	private FauxGravity fauxgravityScript;
	private Vector3 rotationDirection = Vector3.zero;
	private Vector3 moveDirection = Vector3.zero;
	private bool jumping = false;
	private RaycastHit hit;
	private Vector3 acceValue = Vector3.zero;
	
	// for finger
	private Vector2 startPos;
	private Vector2 endPos;
	private float touchDist;
	private int touchDirect;
	private DateTime NextTouch;
	

	
	GUIStyle iosStyle = new GUIStyle();
	
	// Use this for initialization
	void Start () {
		fauxgravityScript = GetComponent<FauxGravity>();
		
		if( moveType == MoveType.ThirdFreezeAcceleration )
		{
			//Screen.orientation = ScreenOrientation.LandscapeLeft;
			acceValue =  Input.acceleration;
		}

		
		touchDist = 0;
		touchDirect = 0;
		NextTouch = DateTime.Now;

		// for GUI
		iosStyle.fontSize = 40;
		iosStyle.normal.textColor = Color.white;
	}
	
	
	void FixedUpdate () {
		
		if( moveType == MoveType.FpsKey )
		{
			// fps
			transform.Rotate(0, Input.GetAxis("Horizontal") * TurnSpeed * Time.deltaTime, 0);
			
			Vector3 rayDirection = transform.forward;
			if( Input.GetAxis("Vertical") < 0 )
				rayDirection = -transform.forward;
			
			//Ray ray = new Ray(transform.position+transform.up*obstacleHeight, transform.forward);
			Ray ray = new Ray(transform.position+transform.up*obstacleHeight, rayDirection);
			
			//Debug.DrawLine(ray.origin, ray.origin + ray.direction * obstacleDistance);   
			if( !Physics.Raycast(ray,out hit, obstacleDistance) )
			{
				transform.position+= transform.forward*Input.GetAxis("Vertical")*moveSpeed*Time.deltaTime;
			}
			

		}
		/*else if( moveType == MoveType.ThirdKey )
		{
			rotationDirection = new Vector3(Input.GetAxis("Horizontal"), 0, Input.GetAxis("Vertical"));
			moveDirection = Vector3.zero;
			if( rotationDirection != Vector3.zero ) {
				
				
				float angle = TurnSpeed*Time.deltaTime;
				//float t = Mathf.Min(1, angle / Vector3.Angle(transform.forward, rotationDirection));
				//Vector3 newForward = Vector3.Slerp(transform.forward, rotationDirection, t);
				
				Vector3 newForward = Vector3.Slerp(transform.forward, combinedFacingDirection,1);
				
				newForward = newForward-Vector3.Project(newForward, transform.up);
				//Debug.DrawLine(transform.position, transform.position+newForward, Color.yellow);
				Quaternion q = new Quaternion();
				q.SetLookRotation(newForward, transform.up);
				transform.rotation = q;
				
				transform.position+= transform.forward*moveSpeed*Time.deltaTime;
			}
		}*/
		else if( moveType == MoveType.ThirdFreezeKey )
		{
			rotationDirection = new Vector3(Input.GetAxis("Horizontal"), 0, Input.GetAxis("Vertical"));
			moveDirection = Vector3.zero;
			if( rotationDirection != Vector3.zero ) {
	
				//apply the movement relative to the attached game object orientation
				moveDirection = transform.TransformDirection(rotationDirection);
	
				//apply the speed to move the game object
				moveDirection *= moveSpeed;

				Ray ray = new Ray(transform.position+transform.up*obstacleHeight, moveDirection);
				//Debug.DrawLine(ray.origin, ray.origin + ray.direction * obstacleDistance);   
				if( !Physics.Raycast(ray,out hit, obstacleDistance) )
				{
					fauxgravityScript.AdjustUp();
					// Move the game object
					//transform.position += moveDirection * Time.deltaTime; // 移動transform的方式
					rigidbody.MovePosition(rigidbody.position + moveDirection * Time.deltaTime); // 移動rigidbody的方式
				}
			}
		}
		else if( moveType == MoveType.ThirdFreezeAcceleration )
		{
			float newHorizontal = 0;
			float newVertical = 0;
			
			Vector3 newAcceValue = Input.acceleration*5f;
			
			if( newAcceValue.z > 0 )
			{
				newHorizontal =  acceValue.x - newAcceValue.x;
				newVertical =  acceValue.y - newAcceValue.y;
			}
			else
			{
				newHorizontal = newAcceValue.x - acceValue.x;
				newVertical = newAcceValue.y - acceValue.y;
			}
			
			
			newHorizontal = rotationDirection.x + newHorizontal;
			if( newHorizontal > 1 ) newHorizontal = 1;
			else if (newHorizontal < -1 ) newHorizontal = -1;
			
			
			newVertical = rotationDirection.z + newVertical;
			if( newVertical > 1 ) newVertical = 1;
			else if (newVertical < -1 ) newVertical = -1;
			
			
			acceValue = newAcceValue;
			
			if( newHorizontal > 0.05 || newHorizontal < -0.05 || newVertical > 0.05 || newVertical < -0.05 )
				rotationDirection = new Vector3(newHorizontal, 0, newVertical );
			else
				rotationDirection = Vector3.zero;
			
			//rotationDirection = new Vector3(Input.GetAxis("Horizontal"), 0, Input.GetAxis("Vertical"));
			moveDirection = Vector3.zero;
			if( rotationDirection != Vector3.zero ) {
	
				//apply the movement relative to the attached game object orientation
				moveDirection = transform.TransformDirection(rotationDirection);
	
				//apply the speed to move the game object
				moveDirection *= moveSpeed;

				Ray ray = new Ray(transform.position+transform.up*obstacleHeight, moveDirection);
				//Debug.DrawLine(ray.origin, ray.origin + ray.direction * obstacleDistance);   
				if( !Physics.Raycast(ray,out hit, obstacleDistance) )
				{
					fauxgravityScript.AdjustUp();
					// Move the game object
					//transform.position += moveDirection * Time.deltaTime; // 移動transform的方式
					rigidbody.MovePosition(rigidbody.position + moveDirection * Time.deltaTime); // 移動rigidbody的方式
				}
			}
		}
		else if( moveType == MoveType.FPSTouch )
		{
			touchDist = 0;
			if( Input.touchCount == 1 )
			{
				Touch touch1 = Input.GetTouch(0);
				
				if( touch1.phase == TouchPhase.Began )
				{
					startPos = touch1.position;
				}
				
				if( touch1.phase == TouchPhase.Ended )
				{
					endPos = touch1.position;
					touchDist = Vector2.Distance(startPos, endPos);
				}
				
				if( touch1.deltaPosition.magnitude > 5 )
				{
					if(  touch1.deltaPosition.x > 0)
					{
						transform.Rotate(0, 1 * TurnSpeed * Time.deltaTime, 0); // turn right
					}
					else if ( touch1.deltaPosition.x < 0 )
					{
						transform.Rotate(0, -1 * TurnSpeed * Time.deltaTime, 0); // turn left
					}
				}
			}

			if( touchDist > 50) 
			{
				float xDirect = endPos.x - startPos.x;
				float yDirect = endPos.y - startPos.y;
				
				float xLength = xDirect;
				float yLength = yDirect;
				
				if( xLength < 0 )
					xLength = -xLength;
				if( yLength < 0 )
					yLength = -yLength;
				
				if( xLength < yLength )  // if move
				{
					if( DateTime.Now > NextTouch )
					{
						if( yDirect > 0 )
						{
							if( touchDirect <1 )
							{
								touchDirect ++;
							}
						}
						else
						{
							if( touchDirect >-1)
							{
								touchDirect --;
							}
						}
						NextTouch = DateTime.Now.AddMilliseconds(500);
					}
				}
				
				touchDist = 0;
			}
			
			
			if( touchDirect != 0 )
			{
				Vector3 rayDirection = transform.forward;
				if( touchDirect < 0 )
					rayDirection = -transform.forward;
	
				//Ray ray = new Ray(transform.position+transform.up*obstacleHeight, transform.forward);
				Ray ray = new Ray(transform.position+transform.up*obstacleHeight, rayDirection);
				
				//Debug.DrawLine(ray.origin, ray.origin + ray.direction * obstacleDistance);   
				if( !Physics.Raycast(ray,out hit, obstacleDistance) )
				{
					transform.position+= transform.forward*touchDirect*moveSpeed*Time.deltaTime;
				}
				else // have wall
				{
					touchDirect = 0;
				}
			}
			
			
		}
		else if( moveType == MoveType.ThirdFreezeTouch )
		{
		}
		
		if( fauxgravityScript.Grounded)
		{
			jumping = false;
			
			if( moveType == MoveType.FpsKey || moveType == MoveType.ThirdFreezeKey )
			{
				// 處理跳躍按鍵
				if (Input.GetKey(jumpKeyCode) && canJump) {
					rigidbody.velocity = rigidbody.velocity+transform.up*Mathf.Sqrt(jumpHeight*fauxgravityScript.fauxGravity);
					jumping = true;
				}
			}
			else if( moveType == MoveType.ThirdFreezeAcceleration )
			{
				// 處理跳躍按鍵
				if ( Input.touchCount == 1 && Input.GetTouch(0).phase == TouchPhase.Began && canJump) {
					rigidbody.velocity = rigidbody.velocity+transform.up*Mathf.Sqrt(jumpHeight*fauxgravityScript.fauxGravity);
					jumping = true;
				}
			}
		}
	}
	

	
	//void OnCollisionEnter (Collision c) {
	//	grounded = true;
	//}

	//void OnCollisionExit (Collision c) {
	//	grounded = false;
	//}
	
	//void OnGUI () {
		//GUI.Label(new Rect(10,10,400,26), string.Format("touchDirect:{0}\ntouchDist:{1}\nDebugCount:{2}\nDeltaPosition:{3}", touchDirect, touchDist, DebugCount, DeltaPosition), iosStyle);
	//}
	
	//
	public Vector3 RotationDirection {
		get { return rotationDirection; }
	}
	
	public Vector3 MoveDirection {
		get { return moveDirection; }
	}
	
	public bool Jumping {
		get { return jumping; }
	}
	
	public int TouchDirect {
		get { return touchDirect; }
	}
}


public enum MoveType { FpsKey, ThirdFreezeKey, ThirdFreezeAcceleration, FPSTouch, ThirdFreezeTouch }