using UnityEngine;
using System.Collections;

public class FauxParticleEmitter : MonoBehaviour {
	
	public Rigidbody ParticleRigibody;
	
	
	public GameObject Planet = null;
	public  Vector3 Geocentric = Vector3.zero;
	public float fauxGravity = 10.0f;
	public float GroundedDrag  = 1f;
	public float EmitterForce = 30;
	public float forceRand = 5;
	public float forceDirectRand = 5;
	public float EmitTimeSpan = 1000;
	public float particleLifeTimeMillSec = 8000;
	public float particleLifeTimeRand = 2000;
	
	public int particleMaxCount = 30;
	public EmitterType emitterType = EmitterType.Forever;
	
	
	
	private System.DateTime nextEmitTime;
	
	private int onceCounter;
	private int foreverCounter;
	
	
	// Use this for initialization
	void Start () {
		onceCounter = 0;
		foreverCounter = 0;
		nextEmitTime = System.DateTime.Now;
	}
	
	
	void FixedUpdate () {
		if( emitterType == EmitterType.Once )
		{
			if( onceCounter < particleMaxCount )
			{
				if( System.DateTime.Now > nextEmitTime)
				{
					CreateParticle();
					nextEmitTime = System.DateTime.Now.AddMilliseconds(EmitTimeSpan);
					onceCounter++;
					foreverCounter++;
				}
			}
		}
		else
		{
			if( foreverCounter < particleMaxCount )
			{
				if( System.DateTime.Now > nextEmitTime)
				{
					CreateParticle();
					nextEmitTime = System.DateTime.Now.AddMilliseconds(EmitTimeSpan);
					foreverCounter++;
				}
			}
		}
		
		
		
	}
	
	private void CreateParticle() {
		
		Rigidbody rigi = (Rigidbody)Instantiate(ParticleRigibody, transform.position , Quaternion.identity);
		FauxParticle fauxParticleScript = rigi.gameObject.GetComponent<FauxParticle>();
		if( fauxParticleScript == null )
		{
			Destroy(rigi.gameObject);
			return;
		}
		else
		{
			fauxParticleScript.fauxparticleEmitter = this;
			fauxParticleScript.LifetimeMillSec = particleLifeTimeMillSec+Random.Range(0,particleLifeTimeRand);
		}
		
		FauxGravity fauxgravityScript = rigi.gameObject.GetComponent<FauxGravity>();
		
		if( fauxgravityScript != null )
		{
			fauxgravityScript.Geocentric = Geocentric;
			fauxgravityScript.fauxGravity = fauxGravity;
			fauxgravityScript.GroundedDrag = GroundedDrag;
			
			if( Planet != null )
			{
				fauxgravityScript.Planet = Planet;
			}
		}
		Vector3 forcePosi = transform.position + new Vector3(
			Random.Range(0,forceDirectRand*2)-forceDirectRand,
			Random.Range(0,forceDirectRand*2)-forceDirectRand,
			Random.Range(0,forceDirectRand*2)-forceDirectRand);
		
		Vector3 forceUp = fauxUp(forcePosi);
		rigi.AddForce( forceUp * fauxGravity * rigi.mass *  (EmitterForce+Random.Range(0f,forceRand)) );
	}
	
	
	public Vector3 fauxUp(Vector3 objPosition) {
		Vector3 geocentric = Geocentric;
		if( Planet != null )
		{
			geocentric = Planet.transform.position + Geocentric;
		}
		Vector3 gravityUp = objPosition - geocentric;
        gravityUp.Normalize();
		return gravityUp;
	}
	
	
	public int ParticleCounter {
		get { return foreverCounter; }
		set { foreverCounter = value; }
	}
}


public enum EmitterType { Once, Forever }